VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Out of Context Menus"
   ClientHeight    =   3105
   ClientLeft      =   1140
   ClientTop       =   1800
   ClientWidth     =   5610
   Height          =   3795
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   3105
   ScaleWidth      =   5610
   Top             =   1170
   Width           =   5730
   Begin VB.TextBox Text1 
      Height          =   795
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "RMenu.frx":0000
      Top             =   120
      Width           =   2115
   End
   Begin MsghookLib.Msghook Msghook1 
      Left            =   2460
      Top             =   300
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
   End
   Begin VB.Menu mMain 
      Caption         =   "Demo"
      Index           =   0
      Begin VB.Menu mDemo 
         Caption         =   "&Default Context Menu"
         Index           =   0
      End
      Begin VB.Menu mDemo 
         Caption         =   "&Custom Context Menu"
         Index           =   1
      End
      Begin VB.Menu mDemo 
         Caption         =   "&No Context Menu"
         Index           =   2
      End
      Begin VB.Menu mDemo 
         Caption         =   "-"
         Index           =   3
      End
      Begin VB.Menu mDemo 
         Caption         =   "E&xit"
         Index           =   4
      End
   End
   Begin VB.Menu mPopup 
      Caption         =   "Custom"
      Visible         =   0   'False
      Begin VB.Menu mCustom 
         Caption         =   "&Undo"
         Index           =   0
      End
      Begin VB.Menu mCustom 
         Caption         =   "-"
         Index           =   1
      End
      Begin VB.Menu mCustom 
         Caption         =   "Cu&t"
         Index           =   2
      End
      Begin VB.Menu mCustom 
         Caption         =   "&Copy"
         Index           =   3
      End
      Begin VB.Menu mCustom 
         Caption         =   "&Paste"
         Index           =   4
      End
      Begin VB.Menu mCustom 
         Caption         =   "&Delete"
         Index           =   5
      End
      Begin VB.Menu mCustom 
         Caption         =   "-"
         Index           =   6
      End
      Begin VB.Menu mCustom 
         Caption         =   "Select &All"
         Index           =   7
      End
      Begin VB.Menu mCustom 
         Caption         =   "-"
         Index           =   8
      End
      Begin VB.Menu mCustom 
         Caption         =   "&Surprise Me!!!"
         Index           =   9
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
'
' Message to hook for context menus.
'
Private Const WM_CONTEXTMENU = &H7B
'
' API/Constants used to Undo textbox change.
'
Private Declare Function SendMessage Lib "user32" Alias _
   "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, _
   ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const EM_CANUNDO = &HC6
Private Const EM_UNDO = &HC7
'
' API used to find Windows directory.
'
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
'
' Menu constants.
'
Private Const mdDefault = 0
Private Const mdCustom = 1
Private Const mdNone = 2
Private Const mdExit = 4
Private Const mcUndo = 0
Private Const mcCut = 2
Private Const mcCopy = 3
Private Const mcPaste = 4
Private Const mcDelete = 5
Private Const mcSelAll = 7
Private Const mcSurprise = 9
'
' Variable to track chosen option
'
Dim MenuOption As Integer

Private Sub Form_Load()
   Dim path As String
   Dim filespec As String
   Dim nRet As Long
   Dim hFile As Long
   '
   ' Put something in textbox
   '
   path = Space(256)
   nRet = GetWindowsDirectory(path, Len(path))
   filespec = Left(path, nRet) & "\win.ini"
   hFile = FreeFile
   Open filespec For Input As hFile
      Text1.Text = Input(LOF(hFile), hFile)
   Close hFile
   '
   ' Setup Msghook
   '
   Msghook1.HwndHook = Text1.hWnd
   Msghook1.Message(WM_CONTEXTMENU) = True
   '
   ' Select initial menu option.
   '
   mDemo_Click mdDefault
End Sub

Private Sub Form_Resize()
   '
   ' Resize textbox to fit form.
   '
   Text1.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
End Sub

Private Sub mDemo_Click(Index As Integer)
   Dim i As Integer
   '
   ' Check chosen option or exit.
   '
   Select Case Index
      Case mdDefault To mdNone
         For i = mdDefault To mdNone
            If i = Index Then
               mDemo(i).Checked = True
            Else
               mDemo(i).Checked = False
            End If
         Next i
         MenuOption = Index
      Case mdExit
         Unload Me
   End Select
End Sub

Private Sub Msghook1_Message(ByVal Msg As Long, ByVal wp As Long, ByVal lp As Long, result As Long)
   Select Case MenuOption
      Case mdDefault
         '
         ' Invoke default window procedure.
         '
         Call Msghook1.InvokeWindowProc(Msg, wp, lp)
      Case mdCustom
         '
         ' Pop hidden custom menu, taking the
         ' new MS keyboard into account.
         '
         PreparePopup Text1
         If lp = &HFFFFFFFF Then
            Me.PopupMenu mPopup, , 0, 0, mCustom(mcSurprise)
         Else
            Me.PopupMenu mPopup, , , , mCustom(mcSurprise)
         End If
      Case mdNone
         '
         ' Do nothing. <g>
         '
   End Select
End Sub

Private Sub PreparePopup(cntl As TextBox)
   '
   ' Can't cut, copy, or delete without
   ' a selection.
   '
   If cntl.SelLength Then
      mCustom(mcCut).Enabled = True
      mCustom(mcCopy).Enabled = True
      mCustom(mcDelete).Enabled = True
   Else
      mCustom(mcCut).Enabled = False
      mCustom(mcCopy).Enabled = False
      mCustom(mcDelete).Enabled = False
   End If
   '
   ' Check clipboard for text to paste.
   '
   If Clipboard.GetFormat(vbCFText) Then
      mCustom(mcPaste).Enabled = True
   Else
      mCustom(mcPaste).Enabled = False
   End If
   '
   ' See if last action can be undone.
   '
   If SendMessage(cntl.hWnd, EM_CANUNDO, 0, 0) Then
      mCustom(mcUndo).Enabled = True
   Else
      mCustom(mcUndo).Enabled = False
   End If
End Sub
