VERSION 2.00
Begin Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3390
   ClientLeft      =   735
   ClientTop       =   2280
   ClientWidth     =   6075
   Height          =   4080
   Left            =   675
   LinkTopic       =   "Form1"
   ScaleHeight     =   3390
   ScaleWidth      =   6075
   Top             =   1650
   Width           =   6195
   Begin MsgHook MsgHook1 
      Left            =   180
      Top             =   2460
   End
   Begin TextBox Text1 
      Height          =   2115
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   60
      Width           =   4875
   End
   Begin Menu mMain 
      Caption         =   "Demo"
      Index           =   0
      Begin Menu mDemo 
         Caption         =   "&Default Context Menu"
         Index           =   0
      End
      Begin Menu mDemo 
         Caption         =   "&Custom Context Menu"
         Index           =   1
      End
      Begin Menu mDemo 
         Caption         =   "&No Context Menu"
         Index           =   2
      End
      Begin Menu mDemo 
         Caption         =   "-"
         Index           =   3
      End
      Begin Menu mDemo 
         Caption         =   "E&xit"
         Index           =   4
      End
   End
   Begin Menu mPopup 
      Caption         =   "Custom"
      Visible         =   0   'False
      Begin Menu mCustom 
         Caption         =   "&Undo"
         Index           =   0
      End
      Begin Menu mCustom 
         Caption         =   "-"
         Index           =   1
      End
      Begin Menu mCustom 
         Caption         =   "Cu&t"
         Index           =   2
      End
      Begin Menu mCustom 
         Caption         =   "&Copy"
         Index           =   3
      End
      Begin Menu mCustom 
         Caption         =   "&Paste"
         Index           =   4
      End
      Begin Menu mCustom 
         Caption         =   "&Delete"
         Index           =   5
      End
      Begin Menu mCustom 
         Caption         =   "-"
         Index           =   6
      End
      Begin Menu mCustom 
         Caption         =   "Select &All"
         Index           =   7
      End
      Begin Menu mCustom 
         Caption         =   "-"
         Index           =   8
      End
      Begin Menu mCustom 
         Caption         =   "&Surprise Me!!!"
         Index           =   9
      End
   End
End
Option Explicit
'
' Variable to track chosen option
'
Dim MenuOption As Integer
'
' Menu constants.
'
Const mdDefault = 0
Const mdCustom = 1
Const mdNone = 2
Const mdExit = 4
Const mcUndo = 0
Const mcCut = 2
Const mcCopy = 3
Const mcPaste = 4
Const mcDelete = 5
Const mcSelAll = 7
Const mcSurprise = 9

Sub Form_Load ()
   Dim path As String
   Dim filespec As String
   Dim nRet As Long
   Dim hFile As Long
   '
   ' Put something in textbox
   '
   path = Space(256)
   nRet = GetWindowsDirectory(path, Len(path))
   filespec = Left(path, nRet) & "\win.ini"
   hFile = FreeFile
   Open filespec For Input As hFile
      Text1.Text = Input(LOF(hFile), hFile)
   Close hFile
   '
   ' Setup Msghook
   '
   Msghook1.HwndHook = Text1.hWnd
   Msghook1.Message(WM_CONTEXTMENU) = True
   '
   ' Select initial menu option.
   '
   mDemo_Click mdDefault
End Sub

Sub Form_Resize ()
   '
   ' Resize textbox to fit form.
   '
   Text1.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
End Sub

Sub mDemo_Click (Index As Integer)
   Dim i As Integer
   '
   ' Check chosen option or exit.
   '
   Select Case Index
      Case mdDefault To mdNone
         For i = mdDefault To mdNone
            If i = Index Then
               mDemo(i).Checked = True
            Else
               mDemo(i).Checked = False
            End If
         Next i
         MenuOption = Index
      Case mdExit
         Unload Me
   End Select
End Sub

Sub MsgHook1_Message (msg As Integer, wParam As Integer, lParam As Long, result As Long)
   Select Case MenuOption
      Case mdDefault
         '
         ' Invoke default window procedure.
         '
         result = InvokeWindowProc(Msghook1.HwndHook, msg, wParam, lParam)
      Case mdCustom
         '
         ' Pop hidden custom menu, taking the
         ' new MS keyboard into account.
         '
         PreparePopup Text1
         If lParam = &HFFFFFFFF Then
            Me.PopupMenu mPopup, 0, 0, 0
         Else
            Me.PopupMenu mPopup
         End If
      Case mdNone
         '
         ' Do nothing. <g>
         '
   End Select
End Sub

Sub PreparePopup (cntl As TextBox)
   '
   ' Can't cut, copy, or delete without
   ' a selection.
   '
   If cntl.SelLength Then
      mCustom(mcCut).Enabled = True
      mCustom(mcCopy).Enabled = True
      mCustom(mcDelete).Enabled = True
   Else
      mCustom(mcCut).Enabled = False
      mCustom(mcCopy).Enabled = False
      mCustom(mcDelete).Enabled = False
   End If
   '
   ' Check clipboard for text to paste.
   '
   If Clipboard.GetFormat(1) Then
      mCustom(mcPaste).Enabled = True
   Else
      mCustom(mcPaste).Enabled = False
   End If
   '
   ' See if last action can be undone.
   '
   If SendMessage(cntl.hWnd, EM_CANUNDO, 0, 0) Then
      mCustom(mcUndo).Enabled = True
   Else
      mCustom(mcUndo).Enabled = False
   End If
End Sub

